-- Lulu88520
-- Script pour les outils du chargeur Weidemann 1502
-- @date  25/05/2017
-- https://www.facebook.com/paulo5090r/

WEID1502TOOL = {};

function WEID1502TOOL.prerequisitesPresent(specializations)
	  return true;
end;

function WEID1502TOOL:load(savegame)
local i = 0;
	self.smokeParticleSystems = {};
	while true do
        local key = string.format("vehicle.smokeParticleSystems.smokeParticleSystem(%d)", i);
		if not hasXMLProperty(self.xmlFile, key) then
			break;
		end;
		local index = Utils.indexToObject(self.components, getXMLString(self.xmlFile, key.."#index"));

		local fruitType = FillUtil.fillTypeNameToInt[getXMLString(self.xmlFile, key.."#type")]
		
		local particleSystem = {};        
        Utils.loadParticleSystem(self.xmlFile, particleSystem, key, index, false, nil, self.baseDirectory)

		table.insert(self.smokeParticleSystems, {fruitType=fruitType, particleSystem=particleSystem});
		i = i + 1;
	end;	
end;

function WEID1502TOOL:delete()
for _, ps in pairs(self.smokeParticleSystems) do
		Utils.deleteParticleSystem(ps.particleSystem);
	end;
end;

function WEID1502TOOL:readStream(streamId, connection)
end;

function WEID1502TOOL:writeStream(streamId, connection)
end;

function WEID1502TOOL:mouseEvent(posX, posY, isDown, isUp, button)
end;

function WEID1502TOOL:keyEvent(unicode, sym, modifier, isDown) 
end;

function WEID1502TOOL:update(dt)	
end;

function WEID1502TOOL:updateTick(dt) 
local speed = self.lastSpeed*3600
	if self.isClient then
		local capaciteActuel = self:getUnitFillLevel(self.shovel.fillUnitIndex);
		for _, ps in pairs(self.smokeParticleSystems) do
			if ps.fruitType == self:getUnitFillType(self.shovel.fillUnitIndex) and capaciteActuel > 300 and speed < 12 then  			
					Utils.setEmittingState(ps.particleSystem, true);				
				else
					Utils.setEmittingState(ps.particleSystem, false);
			end;			
		end;	
	end;	
end;

function WEID1502TOOL:draw() 
end;